def docker_network = 'huscy'

pipeline {
    agent none
    stages {
        stage('Create Docker Network'){
            agent any
            steps{
                script{
                    sh "docker network create $docker_network || true"
                }
            }
        }
        stage('postgres') {
            agent any
            steps{
                script{
                    sh "docker run --name postgres -e \
                        POSTGRES_PASSWORD=mysecretpassword \
                        -e POSTGRES_DB=huscy -d --rm \
                        --network $docker_network postgres:alpine"
                }
                timeout(time: 30, unit: 'SECONDS'){
                    waitUntil{
                        script{
                            def r = sh script: 'docker exec postgres pg_isready', returnStatus: true
                            return(r == 0);
                        }
                    }
                }
            }
        }
        stage('python') {
            agent {
                docker {
                    image 'python:latest'
                    args "--name python --network $docker_network -it \
                         -v \$WORKSPACE/python:/usr/src/myapp -w /usr/src/myapp \
                         python:3 python postgres_connection.py"
                }
            }
            steps {
                sh 'echo hello'
            }
        }
    }
    post {
        always {
            node('jenkins_agent') {
                sh "docker stop postgres"
            }
        }
    }
}
